﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using GestionRestaurante.SRR;
using System.Data.Services.Client;

namespace GestionRestaurante.PagesGestion
{
    /// <summary>
    /// Lógica de interacción para Usuarios.xaml
    /// </summary>
    public partial class Clientes : Page
    {
        private RestauranteEntities context;
        
        public Clientes()
        {
            InitializeComponent();
            var scvUri = App.Current as App;
            Uri sUri = (Uri)scvUri.uriApp;
            context = new RestauranteEntities(sUri);
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {

            this.lbTitulo.Content = this.Title;

            try
            {
    
                // Define a LINQ query that returns Reservas por cliente 
                var clientesQuery = from o in context.Cliente.Expand("Reserva")
                                    select o;


                // Create an DataServiceCollection<T> based on 
                // execution of the LINQ query for Clientes.
                DataServiceCollection<Cliente> clientes = new
                    DataServiceCollection<Cliente>(clientesQuery);

                // Make the DataServiceCollection<T> the binding source for the Grid.
                this.clientesItemsGrid.DataContext = clientes;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Save changes made to objects tracked by the context.
                context.SaveChanges();
                MessageBox.Show("Operación correcta", "Guardar", MessageBoxButton.OK, MessageBoxImage.Information);
            }
            catch (DataServiceRequestException ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }


    }
}
