﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using GestionRestaurante.SRR;
using System.Data.Services.Client;

namespace GestionRestaurante.PagesGestion
{

    /// <summary>
    /// Lógica de interacción para Ofertas.xaml
    /// </summary>
    public partial class Ofertas : Page
    {
        private RestauranteEntities context;
        DataServiceCollection<Cliente> clientes;

        public Ofertas()
        {
            InitializeComponent();

            var scvUri = App.Current as App;
            Uri sUri = (Uri)scvUri.uriApp;
            context = new RestauranteEntities(sUri);
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {

            this.lbTitulo.Content = this.Title;

            try
            {
             

                // Define a LINQ query that returns Clintes 
                var clientesQuery = from c in context.Cliente
                                    select c;


                // Create an DataServiceCollection<T> based on 
                // execution of the LINQ query for Clientes.
                clientes = new DataServiceCollection<Cliente>(clientesQuery);


            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            

            foreach (var item in clientes)
            {
                EnvioCorreo miMail = new EnvioCorreo();
                // Dependiendo del tipo de envio, se deberan introducir los datos adecuados.
                miMail.User = "********@gmail.com";
                miMail.Password = "************";
                miMail.From = "********@gmail.com";

                if (item.bajaPublicidad == 0)
                {
                    if (item.formaEnvio == 0)
                    {
                        //envio mail
                        miMail.To = item.mailCliente;
                        miMail.Subject = txtAsunto.Text;
                        miMail.Body = txtMensaje.Text;
                        try
                        {
                            miMail.SendEMail();
                            //MessageBox.Show(item.mailCliente, "Envio", MessageBoxButton.OK, MessageBoxImage.Information);
                        
                        }
                        catch (DataServiceRequestException ex)
                        {
                            MessageBox.Show(ex.ToString());
                        }
                    }
                    else 
                    {
                        //envio SMS
                        miMail.To = "["+item.phoneCliente+"@sms.com]";
                        miMail.Subject = txtAsunto.Text;
                        miMail.Body = txtMensaje.Text;

                        try
                        {
                            miMail.SendEMail();
                            //MessageBox.Show("[" + item.phoneCliente + "@sms.com]", "Envio", MessageBoxButton.OK, MessageBoxImage.Information);

                        }
                        catch (DataServiceRequestException ex)
                        {
                            MessageBox.Show(ex.ToString());
                        }

                    }
                }
            }

            MessageBox.Show("Enviado correctamente", "Envio", MessageBoxButton.OK, MessageBoxImage.Information);
            Oferta pOferta = new Oferta();
            pOferta.asuntoOferta = this.txtAsunto.Text;
            pOferta.textoOferta = this.txtMensaje.Text;

            context.AddToOferta(pOferta);
            context.SaveChanges();
         }


    }
}
