﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using GestionRestaurante.SRR;
using System.Data.Services.Client;

namespace GestionRestaurante.PagesGestion
{
    /// <summary>
    /// Lógica de interacción para Usuarios.xaml
    /// </summary>
    public partial class Usuarios : Page
    {
        private RestauranteEntities context;
       
        public Usuarios()
        {
            InitializeComponent();

            var scvUri = App.Current as App;
            Uri sUri = (Uri)scvUri.uriApp;
            context = new RestauranteEntities(sUri);
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {

            this.lbTitulo.Content = this.Title;

            try
            {
                // Define a LINQ query that returns Usuarios por Tipo de Usuario
                var usersQuery = from o in context.UsuarioTipo.Expand("Usuario")
                                 //where o.idUserTipo == idUserTipo
                                 select o;


                // Create an DataServiceCollection<T> based on 
                // execution of the LINQ query for Usuarios.
                DataServiceCollection<UsuarioTipo> UsuariosTipos = new
                    DataServiceCollection<UsuarioTipo>(usersQuery);

                // Make the DataServiceCollection<T> the binding source for the Grid.
                this.usuariosItemsGrid.DataContext = UsuariosTipos;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }


        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Save changes made to objects tracked by the context.
                context.SaveChanges();
                MessageBox.Show("Operación correcta", "Guardar", MessageBoxButton.OK, MessageBoxImage.Information);
            }
            catch (DataServiceRequestException ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }
       
    }
}
