using System;
using System.Linq;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Reservas : System.Web.UI.Page
{
    private RTM.RTE context = new RTM.RTE();
    myCliente miCliente = new myCliente();
    
    protected void Page_Load(object sender, EventArgs e)
    {
        
        if (!IsPostBack)
        {
            lblInfo.Visible = false;

            lblNoPsw.Visible = false;
            lblNoUser.Visible = false;

            lblName.Visible = false;
            lblUserName.Visible = false;
            lblPassword.Visible = false;
            lblEmail.Visible = false;
            lblMovil.Visible = false;
            lblFreserva.Visible = false;
            lblObservaciones.Visible = false;

            txtName.Visible = false;
            txtUserName.Visible = false;
            txtPassword.Visible = false;
            txtEmail.Visible = false;
            txtMovil.Visible = false;
            CalendarReservas.Visible = false;
            txtObservaciones.Visible = false;
            btnReservarCli.Visible = false;
            btnReservarNoCli.Visible = false;

        }         

    }

    protected void CalendarReservas_DayRender(object sender, DayRenderEventArgs e)
    {
        if (e.Day.Date < DateTime.Now)
        {
            e.Day.IsSelectable = false;
        }
    }
    protected void btnReservaCliente_Click(object sender, EventArgs e)
    {
        lblName.Visible = false;
        lblEmail.Visible = false;
        lblMovil.Visible = false;
        txtName.Visible = false;
        txtEmail.Visible = false;
        txtMovil.Visible = false;
        
        
        lblUserName.Visible = true;
        lblPassword.Visible = true;
        lblFreserva.Visible = true;
        lblObservaciones.Visible = true;

        txtUserName.Visible = true;
        txtPassword.Visible = true;
        CalendarReservas.Visible = true;
        txtObservaciones.Visible = true;

        btnReservarCli.Visible = true;
        btnReservarNoCli.Visible = false;
        
    }
    protected void btnReservaClienteNuevo_Click(object sender, EventArgs e)
    {
        lblName.Visible = true;
        lblUserName.Visible = true;
        lblPassword.Visible = true;
        lblEmail.Visible = true;
        lblMovil.Visible = true;
        lblFreserva.Visible = true;
        lblObservaciones.Visible = true;

        txtName.Visible = true;
        txtUserName.Visible = true;
        txtPassword.Visible = true;
        txtEmail.Visible = true;
        txtMovil.Visible = true;
        CalendarReservas.Visible = true;
        txtObservaciones.Visible = true;

        btnReservarNoCli.Visible = true;
        btnReservarCli.Visible = false;
    }
    protected void btnReservar_Click(object sender, EventArgs e)
    {
        if (!miCliente.passwordCorrecta(this.txtUserName.Text, this.txtPassword.Text))
            lblNoPsw.Visible = true;
        else
        {
            RTM.Cliente myClient = (from c in context.Cliente
                                    where c.userNameCli == this.txtUserName.Text
                                    select c).First();
            RTM.Reserva myReserva = new RTM.Reserva();
            myReserva.idCliente = myClient.idCliente;
            myReserva.fechaReserva = CalendarReservas.SelectedDate.ToLocalTime();
            myReserva.observaciones = txtObservaciones.Text;
            context.AddToReserva(myReserva);
            context.SaveChanges();
            lblInfo.Text = "Reserva creada correctamente";
            lblInfo.Visible = true;
        }

    }
    protected void btnReservarNoCli_Click(object sender, EventArgs e)
    {
        if (this.CalendarReservas.SelectedDate.ToUniversalTime() < DateTime.Today)
        {
            lblInfo.Visible = true;
            lblInfo.Text = "* Debes seleccionar una fecha!";
        }
        else
        {
            if (miCliente.existeUsuario(this.txtUserName.Text))
            {
                this.lblInfo.Text = "Este nombre de usuario ya existe, escoja otro por favor";
                this.lblInfo.Visible = true;
            }
            else
            {
                RTM.Cliente nuevoCliente = new RTM.Cliente();
                nuevoCliente.nameCliente = this.txtName.Text;
                nuevoCliente.userNameCli = this.txtUserName.Text;
                nuevoCliente.pswCli = this.txtPassword.Text;
                nuevoCliente.mailCliente = this.txtEmail.Text;
                nuevoCliente.phoneCliente = this.txtMovil.Text;

                context.AddToCliente(nuevoCliente);
                context.SaveChanges(); 


                RTM.Cliente myClient = (from c in context.Cliente
                                        where c.userNameCli == this.txtUserName.Text
                                        select c).First();
                RTM.Reserva myReserva = new RTM.Reserva();
                myReserva.idCliente = myClient.idCliente;
                myReserva.fechaReserva = CalendarReservas.SelectedDate.ToLocalTime();
                myReserva.observaciones = txtObservaciones.Text;
                context.AddToReserva(myReserva);
                context.SaveChanges();

                lblInfo.Text = "Usuario y Reserva creados correctamente";
                lblInfo.Visible = true;

            }
        }
 
    }

}
