﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Data.Services.Client;
using appComandas.SRR;
using System.Windows.Data;
using System.Globalization;



namespace appComandas
{
    public partial class MainPage : PhoneApplicationPage
    {
        private RestauranteEntities context;
        private Uri restaurantUri = new Uri("http://192.168.1.200/RestauranteService/Restaurante.svc");
        private DataServiceCollection<Plato> platos;
        private DataServiceCollection<Comanda> comandas;
        private lineaComanda pLComanda;
        public static Cursor Hand { set;  get; }
        //private DataServiceCollection<lineaComanda> lComandas;


        int[] nDeMesa = new int[30];
        int[] nComensales = new int[20];

        // Constructor
        public MainPage()
        {
            InitializeComponent();
           
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {

            for (int i = 0; i <30; i++)
            {
                nDeMesa[i] = i+1;
            }

            for (int i = 0; i < 20; i++)
            {
                nComensales[i] = i + 1;
            }

            var aUser = App.Current as App;
            this.ApplicationTitle.Text = "Hola " + aUser.pName;

            this.lsbNmesa.ItemsSource = nDeMesa;
            this.lsbNcomensales.ItemsSource = nComensales;
            this.lsbCantidad.ItemsSource = nComensales;
            this.txtIDnComanda.Visibility = Visibility.Collapsed;
            
            
            
            // Initialize the context and the binding collection 
            context = new RestauranteEntities(restaurantUri);
            platos = new DataServiceCollection<Plato>(context);

            // Define a LINQ query that returns all customers.
            var query = from p in context.Plato
                        select p;

            // Register for the LoadCompleted event.
            platos.LoadCompleted
                += new EventHandler<LoadCompletedEventArgs>(platos_LoadCompleted);

            // Load the customers feed by executing the LINQ query.
            platos.LoadAsync(query);
           
        }

        void platos_LoadCompleted(object sender, LoadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                // Handling for a paged data feed.
                if (platos.Continuation != null)
                {
                    // Automatically load the next page.
                    platos.LoadNextPartialSetAsync();
                }
                else
                {
                    // Set the data context of the list box control to the sample data.
                    this.ContentPlatos.DataContext = platos;
                }
            }
            else
            {
                MessageBox.Show(string.Format("An error has occurred: {0}", e.Error.Message));
            }
        }

        private void btnNewComanda_Click(object sender, RoutedEventArgs e)
        {
           
            context = new RestauranteEntities(restaurantUri);

            var aUser = App.Current as App;
                      
            Comanda pComanda = new Comanda();

            pComanda.IdUsuario = Int16.Parse(aUser.pUser);
            if (this.lsbNmesa.SelectedValue != null && this.lsbNcomensales.SelectedValue != null)
            {
                pComanda.numMesa = (int)this.lsbNmesa.SelectedValue;
                pComanda.nComensales = (int)this.lsbNcomensales.SelectedValue;

                pComanda.controlComanda = 0;
                context.AddToComanda(pComanda);

                try
                {
                    // Complete the save changes operation.
                    context.BeginSaveChanges(OnChangesSaved, this.context);
                    
                }
                catch (DataServiceRequestException ex)
                {
                    // Ideally, we should not create a UI element 
                    // from the ViewModel. A better way is to use a 
                    // service or event to report exceptions to the view.
                    MessageBox.Show(string.Format(ex.Message, this.context.BaseUri));
                }
                this.ContentPlatos.Visibility = Visibility.Visible;
                this.txtIDnComanda.Visibility = Visibility.Visible;
            }
            else
                MessageBox.Show("Selecciona nº mesa y comensales");
           
        }

        private void mostrarComanda()
        {
            // Initialize the context and the binding collection 
            context = new RestauranteEntities(restaurantUri);
            comandas  = new DataServiceCollection<Comanda>(context);

             var aUser = App.Current as App;
             int IdUser = Int16.Parse(aUser.pUser);
            
            // Define a LINQ query that returns all customers.
            var query = from c in context.Comanda
                        where IdUser == c.IdUsuario
                        select c;

            // Register for the LoadCompleted event.
            comandas.LoadCompleted
                += new EventHandler<LoadCompletedEventArgs>(comandas_LoadCompleted);

            // Load the customers feed by executing the LINQ query.
            comandas.LoadAsync(query);
        }

        void comandas_LoadCompleted(object sender, LoadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                // Handling for a paged data feed.
                if (comandas.Continuation != null)
                {
                    // Automatically load the next page.
                    comandas.LoadNextPartialSetAsync();
                }
                else
                {
                    // Set the data context of the list box control to the sample data.
                    var aUser = App.Current as App;
                    aUser.pIDcomanda = comandas.Last().idComanda.ToString();
                    this.txtIDnComanda.Text = "Nº Comanda: " + aUser.pIDcomanda;
                }
            }
            else
            {
                MessageBox.Show(string.Format("An error has occurred: {0}", e.Error.Message));
            }
        }

        private void OnChangesSaved(IAsyncResult result)
        {
            // Use the Dispatcher to ensure that the 
            // asynchronous call returns in the correct thread.
            Deployment.Current.Dispatcher.BeginInvoke(() =>
            {
                this.context = result.AsyncState as SRR.RestauranteEntities;

                try
                {
                    // Complete the save changes operation.
                    this.context.EndSaveChanges(result);
                }
                catch (DataServiceRequestException ex)
                {
                    // Ideally, we should not create a UI element 
                    // from the ViewModel. A better way is to use a 
                    // service or event to report exceptions to the view.
                    MessageBox.Show(string.Format(ex.Message, this.context.BaseUri));
                }
            }
            );

           mostrarComanda();
            
        }


        private void btnNuevaLcomanda_Click(object sender, RoutedEventArgs e)
        {
            context = new RestauranteEntities(restaurantUri);
            Plato plt1 = new Plato();
            

            var aUser = App.Current as App;

            //lineaComanda pLComanda = new lineaComanda();
            pLComanda = new lineaComanda();

            pLComanda.idComanda = Int16.Parse(aUser.pIDcomanda);

            if (this.listPlatos.SelectedItem != null && this.lsbCantidad.SelectedValue != null)
            {
                plt1 = (Plato)this.listPlatos.SelectedItem;
                pLComanda.idPlato = plt1.idPlato;
                pLComanda.cantidad = (int)this.lsbCantidad.SelectedValue;
                pLComanda.modificada = 0;

                context.AddTolineaComanda(pLComanda);
 
               try
                {
                    // Complete the save changes operation.
                    context.BeginSaveChanges(OnChangesSaved, this.context);

                }
                catch (DataServiceRequestException ex)
                {
                    // Ideally, we should not create a UI element 
                    // from the ViewModel. A better way is to use a 
                    // service or event to report exceptions to the view.
                    MessageBox.Show(string.Format(ex.Message, this.context.BaseUri));
                }
            }
            else
                MessageBox.Show("Selecciona plato y cantidad");        
        }

        private void btnModificarLcomanda_Click(object sender, RoutedEventArgs e)
        {
           // Initialize the context and the binding collection
  
            var aUser = App.Current as App;
            int IdComanda = Int16.Parse(aUser.pIDcomanda);

            Plato plt1 = new Plato();
            plt1 = (Plato)this.listPlatos.SelectedItem;
            int idPlato = plt1.idPlato;

            pLComanda.idComanda = IdComanda;
            pLComanda.idPlato = idPlato;
            pLComanda.cantidad = (int)this.lsbCantidad.SelectedValue;
            pLComanda.modificada = 1;

            try
            {
                // Complete the save changes operation.
                context.UpdateObject(pLComanda);
                context.BeginSaveChanges(OnChangesSaved2, this.context);
                
            }
            catch (DataServiceRequestException ex)
            {
                // Ideally, we should not create a UI element 
                // from the ViewModel. A better way is to use a 
                // service or event to report exceptions to the view.
                MessageBox.Show(string.Format(ex.Message, this.context.BaseUri));
            }

        }

        private void OnChangesSaved2(IAsyncResult result)
        {
            // Use the Dispatcher to ensure that the 
            // asynchronous call returns in the correct thread.
            Deployment.Current.Dispatcher.BeginInvoke(() =>
            {
                this.context = result.AsyncState as SRR.RestauranteEntities;

                try
                {
                    // Complete the save changes operation.
                    this.context.EndSaveChanges(result);
                }
                catch (DataServiceRequestException ex)
                {
                    // Ideally, we should not create a UI element 
                    // from the ViewModel. A better way is to use a 
                    // service or event to report exceptions to the view.
                    MessageBox.Show(string.Format(ex.Message, this.context.BaseUri));
                }
            }
            );

        }

        private void btnCerrarComanda_Click(object sender, RoutedEventArgs e)
        {
            this.lsbNmesa.SelectedValue = null;
            this.lsbNcomensales.SelectedValue = null;
            this.txtIDnComanda.Text = "";
            this.ContentPlatos.Visibility = Visibility.Collapsed;
            this.lsbCantidad.SelectedValue = null;
            this.listPlatos.SelectedItem = null;
            this.txtIDnComanda.Visibility = Visibility.Collapsed;

           
        }

    }
}